What's New in Version 4.52?
===========================
(Released on November 16, 1998)

NoteTab version 4.5x introduced some very significant enhancements to the Clipbook tool. It is now programmable and supports features such as variables, functions, commands, conditional statements, events, etc.! Furthermore, NoteTab also integrates support for Perl and Gawk interpreters; scripts can be stored in NoteTab and applied directly to highlighted text or a whole document. Non-programmers also benefit much from these new capabilities as experienced users provide Clipbook libraries to extend the capabilities of NoteTab. These libraries can be downloaded for free from the Clipbook repository on the following web page:

   http://www.notetab.com/libraries.htm

Many features have been significantly enhanced and useful new tools have been added. This improved version will benefit everyone, from novice to demanding experienced users.

Another important change with this version is the name of "Super NoteTab." This NoteTab variant has now been renamed "NoteTab Standard" (or NoteTab Std). It is hoped that this change of name will make it less confusing to users since many felt the prefix "Super" made the program sound better than the more advanced "Pro" version.


Changes in Version 4.52
-----------------------
*  Insert HTML links and images by way of the File Open dialog box. If text is highlighted when the command is chosen, the tags wrap around it. Note that the File Open dialog box always points to the last used directory. Menu:
Document|Insert HTML Link/Image (Shift+Ctrl+F5)

* NoteTab Pro: color of <!-- --> comment tags is now adjustable through the Options dialog box on the Colors tab.

* NoteTab Pro: supports WordStar key mapping (Options dialog box on Advanced tab).

* Disk Search now accepts regular expressions too. Set through the "Find what" field's shortcut menu.

* NoteTab now checks that the size of a newly saved file matches the size of the text. The reason behind this feature is that some people saving to certain servers sometimes experienced a loss of data (truncated files). Although this is not caused by NoteTab, this extra checking may help the eventual loss of data by warning you when the problem is detected.

* Quick List's shortcut menu now offers a "Copy Name" command to copy the file name to the Clipboard.

* Clips: the OnClipboardChange event no longer causes the listbox's selection bar to shift to it whenever it is invoked.

* Minor bug fixes.

Clip Language Enhancements:
...........................
* New default label type: Skip_xx
Use this label to skip a specified number of Clip instructions. xx represents a number (positive or negative). For example, Skip_3 will skip the next three lines in the Clip. "Skip" and "Skip_1" have the same effect. These labels do not work in NoteTab Light (unless it is in trial mode).

^!FocusApp AppTitle
Activates the application window with a title caption that matches the specified text. The error flag is set if no matching window is found. For example, if the Windows calculator utility is open, the following command will bring it to the front:
   ^!FocusApp Calculator
Most applications usually show other information in the title bar. For these cases, you can use an asterisk "*" either at the beginning or the end of the AppTitle text to specify that the text should match the end or the beginning of the title respectively. For example, MS Wordpad displays the document name in front of the program name, so the following instruction will work if Wordpad is open:
   ^!FocusApp *WordPad

^$GetAppTitle$
or
^$GetAppTitle(TitleText)$
Returns the full title of the active application window when no title is specified, or the window matching the specified text.

^!IfAppOpen AppTitle GoToLabelTrue [ELSE GoToLabelFalse]
Jumps to the specified label if the a window with the indicated title caption is found. For example, if the Windows calculator utility is open, the following command will continue execution after the CalcOpen label:
    ^!IfAppOpen Calculator CalcOpen
Most applications usually show other information in the title bar. For these cases, you can use an asterisk "*" either at the beginning or the end of the AppTitle text to specify that the text should match the end or the beginning of the title respectively. For example, MS Wordpad displays the document name in front of the program name, so the following instruction will work if Wordpad is open:
   ^!IfAppOpen *WordPad WordPadOpen

^!IfLabelExist LabelName GoToLabelTrue [ELSE GoToLabelFalse]
Jumps to the specified label if the indicated label name exists in the active Clip.

^!SetScreenUpdate [On|Off]
Enables or disabled updating of the NoteTab application window. Disabling updating when a repetetive sequence of Clip commands affects the text layout can significantly improve the processing speed. The scope of this command is limited to the Clip (and eventual sub-Clips) where it was invoked. When a Clip ends, screen updating is automatically re-enabled.

^!SetErrorLabel LabelName
Defines a label to which execution should jump whenever the error flag is set. The scope of this command is limited to the Clip where it was invoked. When an error label is defined, the ^!IfError command is ignored.

^!SetCursorPara Row:Col
Similar to ^!SetCursor command but treats long word-wrapped lines as single lines. Both functions have the same effect if word wrap is turned off.

^!OpenFavorites CategoryName
Opens all the documents listed in the specified Favorites list. CategoryName should be specified without a path name or extension.

^!SaveFavorites CategoryName
Adds all the currently open document names to the specified Favorites list. The Favorites category is created if it doesn't exist. CategoryName should be specified without a path name or extension.

^!ShowHeadings [True|False]
Shows or hides Outline heading names in the editor window.

^!ReloadLibrary
Reloads the current Clipbook library. Useful if another application has modified it.

^$GetText$
Returns the whole text contained in the active document.

^$StrSort("Str";CaseSensitive;Ascending;RemoveDuplicates)$
Returns the specified text "Str" sorted according to the defined criteria. For example, the following instruction will sort the lines contained in the Clipboard, in ascending order, ignoring character case, and removing duplicates:
^$StrSort("^$GetClipboard$";False;True;True)$

^$StrPosRight("SubStr";"Str";CaseSensitive)$
Similar to the ^$StrPos()$ function but searches from right to left.

^$StrPosMid("SubStr";"Str";StartIndex;CaseSensitive)$
Similar to the ^$StrPos()$ function but starts searching from the specified index position.

^$StrCopyRight("Str";Amount)$
Similar to ^$StrCopy()$ but copies the substring from the end of the specified string.

^$IsShowHeadings$
Returns 1 if headings are displayed in the outline document window and 0 if they are not.

^$IsHex(Value)$
Returns 1 if specified text is a hexadecimal number and 0 if it is not.

^$HexToInt(Value)$
Returns the specified hexadecimal value as an integer.

^$IntToHex(Value)$
Returns the specified integer value as an hexadecimal number.

^$GetIndexTopicName(Index)$ renamed ^$GetTopicName[(Index)]$
The old name is still kept for compatibility purposes.

^$GetIndexDocName(Index)$ renamed ^$GetDocName[(Index)]$
The old name is still kept for compatibility purposes.

^!CopyFile "FileSpecs" "Destination"
Now overwrites the destination file if it exists (actually sends it to the recycle bin).


Changes in Version 4.51
-----------------------
* Improved Favorites menu: Category menu items now open up to display their content. Each Category submenu also includes a "Make Default" and "Open All" command.

* Added new functionality to Favorites feature: pressing "Ctrl + Favorites menu item" opens the Save As dialog box configured according to the directory and file name represented by the item. Useful for saving documents in a specific directory or with a predefined name.

* Improved "Strip HTML Tags" function. Comments using <!--...--> tags are now properly removed. List items are preceded with bullets or numbers depending on the nature of the list.

* Toolbar/shortcut menu now offer the Justify and Reformat commands.

* New option to disable warnings when binary characters are substituted in loaded files.

* Document tabs can be configured to make a sound when clicked with the mouse.

* Added support for multiple file masks when doing Search Disk operations: c:\NoteTab\*.txt;*.otl;*.htm*

* New shortcuts to move focus between the Clipbook and the active document: Shift+F4, and between the Quick List and the active document: Shift+F7

* NoteTab Pro now supports the following keyboard actions:
   Ctrl+Up/Down - moves cursor from one paragraph to the next
   Ctrl+Backspace - deletes the word to the left of the cursor

* Added support for basic regular expressions:
   + Find and Replace dialog box:
       click on empty area with right mouse button and choose "Regular Expression"
   + Find and Replace Clipbook commands:
       use new option: "R"
   - Important: the Replace criteria does not support regular expressions at this stage.

-> Regular Expression tokens:
  * = match zero or more of preceding character
  ^ = beginning of line
  $ = end of line
  \ = escape next character
  - = used in [a-z] type expressions
  ^ = negate next character/range in [a-z] expression
  [ = intro for [a-z] expressions
  ] = outro for [a-z] expressions
  . = match any single character

* New option for Find and Replace Clip commands: "C" forces command search for whole words only (see Help for details).

^!SetWordWrap ON/OFF
Clip command to change word wrap mode in active document.

^$Calc(Expression[;Decimals])$
Clip function for calculating mathematical expressions.

^$GetDate(DateMask)$
Clip function for configuring dates and time based on mask.

^$StrFixLines("AnyText")$
Clip function to correct carriage returns in text criteria.

^$IsBookmark(Index)$
Clip function to determine if specified bookmark is used.

^$GetTopicIndex[(TopicName)]$
The GetTopicIndex function can now optionally accept a topic name, and returns its index number.

^!SetHintInfo AnyText
Clip command to turn status bar Clip messages on or off. When you specify a text, it will be displayed in the status bar instead of the usual Clip message. To re-enable the display of normal Clip messages, just invoke the command without any text. This command only has an effect during the time a the Clip is running.

^!SetIniFile Name
Defines where Clip variables are saved when using the SaveValue command and other related functions/commands. By default, variables are saved in NoteTab's INI file (or registry if so configured). Use this command to define a different INI file. If you do not specify a path in the name, the specified INI file will be created in the Libraries directory. If you plan to distribute your library file, consider giving your INI file the same name as your library file (without the extension); you can use the ^$GetLibraryName$ for this purpose. The scope of this command is limited to the library in which is invoked. It is reset when you change libraries or close the Clipbook. Invoke the command with no name to save again in NoteTab's INI file.
The following commands and functions support an optional section name if you specify an alternative INI file with the SetIniFile command:
  ^!SaveValue [Section:]Key=Value
  ^$GetValue("[Section:]Key")$
  ^!ClearValue [Section:]Key
  ^!ClearValues [Section]

^$GetIniFile$
Returns the name of the INI file defined by the SetIniFile command. Returns a blank string if NoteTab's INI file is used.

^!IfError now supports ELSE labels.

^!Select Eol/Bol now extends the pre-existing selection.

* Improved speed when launching console applications.

* Improved behaviour of TypeBack and PasteBack Clip commands.

* Maths parser now supports local decimal delimiter (e.g. Switzerland: PI = 3,14159).

* Added missing topic on "Mask Characters" to Help file.

* Fixed removal of Duplicates option which was ignored by the Sort command.

* Printing through NoteTab from Windows Explorer now works again.

* Fixed bracket matching bug.

* Fixed minor errors in the Clip Assistant library.

* Other minor enhancements and bug fixes.


Main Changes in Version 4.5
---------------------------
* Many enhancements to the Clipbook syntax. The Clipbook is now programmable. Some of the features are only available in the commercial and trial versions of NoteTab. A warning is displayed in NoteTab Light if you attempt to activate a Clip that uses enhanced code which is not available in the Freeware version.

* You can now double-click in listbox controls within a Clip Wizard as an equivalent to clicking on the OK button.

* Clip names can be "disabled" by placing an underscore (_) in front of the name. The color of the name changes to gray and the user cannot execute the Clip with the mouse or the keyboard. Disabled Clips can however be executed from other Clips. Just add another underscore in front if you want such a character displayed in the name but don't want the Clip to be disabled.

* The Clip Assistant now displays Clip Wizards to help develop Clip programs. Only fully operational in the commercial and trial versions of NoteTab.
Menu: Tools|Quick List Properties|Clip Assistant

* Integrated support for Perl and Gawk scripts (through Clipbook commands; see ^!RunPerl and ^!RunGawk).

* Significantly updated the HTML Clipbook library and improved several of the others.

* HTML-Color picker to insert color codes in web page.
Menu: Document|Insert HTML Color (Ctrl+F5)

* NoteTab Pro: Improved HTML-tag highlighting. Entity names are now highlighted, as well as tags containing carriage-returns. Comment tags are highlighted as disabled text (gray by default).

* NoteTab Pro: Optional left-margin ruler to display line numbers (menu: View|Line Numbers).

* NoteTab Pro: You can now jump to a specific paragraph number (as opposed to wrapped lines) with the Search|Go to Line command. Just place a letter "p" in front of the number to signify that it represents a paragraph number rather than a line number (no difference when word wrap is off). For example: "p20" will set the cursor at the beginning of the 20th paragraph. Note that a paragraph, as described here, represents a line that starts from the end of the previous paragraph or the start of the document, and ends with a carriage return or at the end of the document.

* Justify command. This command is only available in the commercial and trial versions of NoteTab.
Menu: Modify|Alignment|Justify

* Reformat Lines command (with option to justify). This command is only available in the commercial and trial versions of NoteTab.
Menu: Modify|Lines|Reformat Lines (Ctrl+Shift+M)

* Count command to count the frequency of a text criteria.
Menu: Search|Count Occurrences

* "Quick Open Links" option under the Tools menu; when set you do not have to hold down the Ctrl key to activate a hyperlink with the mouse.

* Hyperlinks in documents can now launch other programs.

* Improved launching of NoteTab when multiple copies are executed simultaneously.

* Added commands in system menu of Find/Replace/Search Disk dialogs to let you change the default opening position of the window. Set the command "Open Centered" to determine if the window should be opened centered in the screen; turning it off will cause it to open at the current position.

* Added "Round" function to Maths parser.

* "File List" tool renamed "Quick List". You can now specify multiple file-types in Quick List when displaying disk files. Each distinct criteria must be separated with a semi colon (;). Example: c:\images\*.gif;*.jpg;*.jpeg

* New command-line parameter to set Clipbook library: "/L=LibraryName".

* Clipbook: ^!Insert command has been renamed ^!InsertFile.

* New switch for ^!Find and ^!Replace Clip commands: "H", limits search within highlighted text. The option is ignored if no text is highlighted.

* You can now set the font of the Find/Replace fields in the corresponding dialog boxes. Right click on a blank area of the dialog box to open the shortcut menu with the Font command.

* By default, tab drag-and-drop reordering is now disabled when the document tabs are stacked. You can enable drag-and-drop reordering through the tab bar's shortcut menu command "Allow Reordering" or by double-clicking on the tab (toggles the setting).

* Certain NoteTab file types are now organized in subdirectories. The following structure is used:
 NoteTab\
   |_ Libraries\       (takes all *.clb files)
   |_ Scripts\         (can use for Perl, Gawk, and other scripts)
   |_ Sounds\          (takes all *.wav files)
   |_ Favorites\       (takes all *.fvr files)
   |_ Dictionaries\    (takes thesaurus and all dictionary files: *.thr, *.dct, *.udt)
   |_ Documents\       (can use for NoteTab documents: *.txt, *.otl, etc.)
   |_ Templates\       (takes all *.tpl files)

* Changed the way the toolbar icons are loaded. This new method should fix the display problem on systems not running Internet Explorer 4.0 or higher.

* On computers with the latest version of the MS IntelliPoint software installed, Windows Explorer would crash whenever NoteTab v4.01 was launched. This incompatibility problem has been fixed in v4.5. If you have an older version of the mouse driver and the scroll wheel no longer works in NoteTab v4.5, execute the editor with the following switch in the command line (you only need to do this once):
  NotePro.exe /IntelliOn
or
  NoteTab.exe /IntelliOn
or you can update your IntelliPoint software by downloading an update from:
http://www.microsoft.com/products/hardware/mouse/driver/default.htm
If you decide to update the IntelliPoint software at a later date, you should disable the switch after you have installed it by using the following command-line switch: /IntelliOff

* Many minor enhancements and glitch fixes.



Main Changes in Version 4.01
----------------------------
NoteTab version 4.0 is the most important upgrade since the introduction of the innovative Editor Clipbook tool in January 1997. You will find many useful new features and lots of improvements. This version is more user friendly, faster, and offers features that will please both power users and more casual users. Several new tools and commands are available for the first time in a text editor.

The version number of Super NoteTab has jumped from 2.63e to 4.0 instead of 3.0. This was done to align the version number with that of NoteTab Pro.


* 4.011: Text statistics now also show frequency percentage and can be sorted in frequency of occurrences (from word list's shortcut menu).

* 4.011: Fixed a small bug with the Font dialog box; NoteTab could not detect a change if only the font script was modified (important for non-Western scripts).

* New option "Warn Partial Loading" on Files tab in Options dialog box warns if a file has only been partially loaded due to the presence of null characters.

* NoteTab will now prompt you if a large selection (1024 or more characters) is going to be deleted as a result of typing text. This feature protects your text from accidental deletions.

* Image files (GIF, JPG, GIF) dragged from the File List tool (shortcut: F6) into an HTML document will now create a tag that includes the size attributes.

* The Find/Replace feature will now prompt you to resume a search from the beginning of a document if no match is found. If the scope is limited to the current document, selected text is more than 30 characters and at least twice as large as the search criteria, then Find/Replace will only search within the selected text.

* Used another method to control positioning of Windows standard dialog boxes (Font, File Open/Save, Message Box, etc.). Hopefully, dialogs will not be displayed behind the application window under any circumstances.

* NTP: New command for converting tabs to spaces (Modify | Spaces | Tabs to Spaces).

* NTP: When the Auto Indent option is set, pressing Backspace at the beginning of an indented word now aligns it with the indent on the previous line.

* Added optional toolbar button "Strip Tags." This command removes HTML tags but preserves links in the resulting document.

* Spaces are now allowed in mathematical expressions that are evaluated by NoteTab.

* Changed the choice of icons available for NoteTab and associated files.

* " ( ) { } [ ] < > characters are now also counted and displayed in the Text Statistics window. Useful to check for correct matches.

* Clip commands are displayed in the status bar as they get executed.

* Additional or improved Clipbook commands:
^!SAVE:AS [FileName]
If you specify an optional file name, the Save As dialog box is not displayed and the specified file name is used.

^!PROMPT:message
The Prompt command now accepts an optional message.

^!CONTINUE:message
Shows an OK/Cancel dialog box with optional message; if the user presses the Cancel button, Clip execution is stopped.

^!JUMP:LINE_START
Places cursor at the beginning of the current line.

^!JUMP:LINE_END
Places cursor at the end of the current line.

^!JUMP:SELECT_START
Places cursor at the beginning of the selection and unselects the text.

^!JUMP:SELECT_END
Places cursor at the end of the selection and unselects the text.

^!REPLACE:SearchText	ReplaceText	Options [TIBGWSA]
New behavior: you must now use the option "A" to replace all occurrences within the defined scope; otherwise only the next occurrence is replaced. If the options G and W are not used, selected text is more than 30 characters and at least twice as large as the search criteria, the Replace function will only operate within the selected text. Use the option "S" if you don't want NoteTab to display search/replace messages.

^!FIND:SearchText	Options [TIBGWS]
New behavior: if the options G and W are not used, selected text is more than 30 characters and at least twice as large as the search criteria, the search function will only operate within the selected text. Use the option "S" if you don't want NoteTab to display search messages.

^!RUN:CommandLine
Use this command to launch DOS applications (if the standard "^!CommandLine" does not work).

^!REFRESH:
Use after file management actions to update the list of available Clipbook libraries and the content of the File List. It also checks if any of the open documents were changed on disk.

* Other minor interface improvements and several small glitches fixed.


The NoteTab Mailing List
------------------------
The mailing list is a great place to meet other NoteTab users - friendly people from all walks of life, and ranging from complete beginners to experts. If you are a "newbie", ask some of the "old timers" some basic questions to help get you started. Also use this list to exchange ideas, share neat tips and tricks, ask questions, suggest new features, etc. You will find more information about this list on the following web page:

   http://www.notetab.com/maillist.htm (main site)
or
   http://www.notetab.ch/maillist.htm (Swiss site)



Major New Features Include...
-----------------------------
-> Many new commands in the Modify menu

-> Many new options in the Options dialog box

-> More than 80 commands available for the toolbar

-> Customizable editor shortcut menu

-> Search/replace text criteria can be any size (before the limit was 255 characters)

-> NoteTab Pro now accepts multiple line search/replace criteria (^P token)

-> File List replaces the Document Selector and is docked in the main window. Choice to view list of open documents, Favorites, or disk files (press F6 to display it)

-> Supports document outlines (open the file Readme.OTL for an example of the possibilities)

-> Supports document templates (open the file Sample.TPL for an example of the possibilities)

-> Search/Replace through files on disk (press Ctrl+D)

-> Hyperlinks between and within documents

-> Display two documents side by side (Shift+Ctrl+W)

-> Clipbook button bar for easy access to libraries

-> You can now edit individual Clipbook items in a normal document window (menu Tools|Clipbook|Clipbook Item Editor). Each time you select an item from the Clipbook window, it is displayed in the document.

-> You can display Wizard-like dialogs with the Clipbook for user input (see HTML examples; e.g. HTML Begin).

-> You can create file management scripts with the new Clipbook syntax and execute program commands

-> The program can calculate! Look at the new Convert Clipbook library for examples.

-> The program can also calculate mathematical formula in a document. For example, if you enter the following formula in a document:
    Sin(3)*5=
and then press Ctrl+E (or from menu Tools|Calculate Expression), the result will be added after the equal sign. If there is no equal sign, or if the document is Read-Only then it copies the result to the Clipboard and displays it in a small window.
Supported mathematical operators and functions are listed in the Help file.

-> NoteTab makes the popular "HTML Reference Library" (by Stephen Le Hunte) available from the Help menu. If you have HTMLib version 3.0 or older, you can install the package in the same directory as NoteTab. Another method that works with all versions is to create a shortcut* to the HTMLib.exe file in the NoteTab directory. The highly recommended "HTML Reference Library" is available from:
  http://hot.virtual-pc.com/htmlib/
(* to create the shortcut: 1. open Explorer and select the HTMLib file; 2. press Ctrl+C to copy it to the Clipboard; 3. select the NoteTab directory and choose the command "paste Shortcut" from the Edit menu. The menu command will be displayed in NoteTab after you restart it.)

-> And lots more...


Hope you enjoy the new features!
--Eric G.V. Fookes

________________________________________________________
NoteTab™ is a trademark of Eric G.V. Fookes, Switzerland 
 Copyright © 1995-1998, Eric G.V. Fookes, Switzerland
              - All Rights Reserved -

Windows is a trademark of Microsoft Corporation registered in the U.S. and other countries.  
All other trademarks and service marks are the property of their respective owners.
